! Main program
Program AgeNe

    IMPLICIT NONE
    integer :: N, ierror, maxage, NPop, IUnit, IOut, j, m, indStop, model, &
            LineSkipped, LineRead, ILog, ILogNum, nLog, nRun, nRun0, ageErr

! model < 0: haploid
! model = 0: two-sex, data for females should go first.
! model = 1: two-sex, with sex change, female -> male.
! model = 2: two-sex, with sex change, male -> female.


    real :: initialrm
    character(200) filename, mystr, InpName
    character(20) info, logname
    character reply
    logical xfile
    IUnit = 1
    IOut = 2
    ILogNum = 3
    ILog = 0
    xfile = .false.
    call GetInputFile (IUnit, InpName)
    LineSkipped = 1    !lines to be skipped before getting into data
    LineRead = 0
    logname = "AgeNe.log"
    CALL AskQuestion(filename, logname, InpName, N, "Output File Name? ")

    if (filename == "") stop "No Output File is given"
    OPEN (IOut, FILE = filename, STATUS = "UNKNOWN", IOSTAT=ierror)
    if (ierror <> 0) stop "Cannnot open file for output"
    call Version (IOut, InpName)
    ierror = 0
    nRun = 0
    nLog = 0
    do while (ierror == 0)
        nRun0 = nRun
        call GetInputType(LineSkipped, LineRead, IUnit, IOut, model, NPop, &
                        maxage, initialrm, ierror, xfile)
        if (ierror <> 0) exit
        If (xfile) then
            nLog = nLog+1
            ILog = ILogNum
            if (nLog == 1) then
                OPEN (ILog, FILE = "AgeNe.log", STATUS = "UNKNOWN", IOSTAT=ierror)
            else    ! Log file was opened before
                write (ILog, '(A)')
                write (ILog, '(A)')
            end if
            write (ILog, 15) "Details for Running Input ", nRun0+1
            call Dashes (ILog, 30)
        else
            ILog = 0
        end if
        nRun = nRun + 1
        If (model < 0) then
            call Haploid (IUnit, IOut, model, maxage, NPop, LineSkipped, &
                        LineRead, ierror, ILog)
        Else
            call TwoSex (IUnit, IOut, model,  maxage, NPop, initialrm, &
                        LineSkipped, LineRead, ierror, ageErr, ILog)
        End If
    end do
!    if (ierror <> 0 .and. nRun0 < nRun) then
    if (ierror <> 0) then
    ! only print error message if data were missing: when nRun0=nRun, the end
    ! of data file is encountered by GetInputType, not by Haploid or TwoSex
        if (ierror > 0) then
            if (ageErr > 0) then
                write (*, 20) LineRead-maxage+ageErr, ageErr
                write (IOut, 20) LineRead-maxage+ageErr, ageErr
                if (ILog>0) write (ILog, 20) LineRead-maxage+ageErr, ageErr
            else
                write (*, 99) LineRead
            end if
        else if (nRun0 < nRun) then ! ierror < 0: end of file, only show error
        ! message if on the way to read next data but encounter end of file
            write (*, 199) LineRead
        end if
    end if

99  format (1x, 'Error in input file on line', I5, '. Program aborted.')
199  format (1x, 'Unexpected end of input at line', I5, '. Program aborted.')
10  format (/,1x, 'The age numbering is not in the order.',/, 1x, &
            'Age, survival/birth rates, Poisson factor on line', I4,':', &
            /,5x, I6, 3(4x,f8.2), /, 1x, 'Continue? ')
15  format (A, I3)
20  format (1x, "Error in input file on line", I5, /, 1x, &
        "Predetermined fraction male at age ", I3, " does not allow sex change.")


end program

